unit Rombbtn;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, ExtCtrls;

type

  TRombButtons = class(TCustomControl)
  private
    { Private declarations }
    FOnLeftClick:TNotifyEvent;
    FOnRightClick:TNotifyEvent;
    FOnUpClick:TNotifyEvent;
    FOnDownClick:TNotifyEvent;
    FDrawContur:Boolean;
    Btn:Integer;
    procedure TimerExpired(Sender: TObject);
    procedure WMSize(var M: TWMSize); message wm_Size;
    procedure WMSetFocus(var Message: TWMSetFocus); message WM_SETFOCUS;
    procedure WMKillFocus(var Message: TWMKillFocus); message WM_KILLFOCUS;
    procedure WMGetDlgCode(var M: TWMGetDlgCode); message wm_GetDlgCode;
    procedure KeyDown(var Key: Word; Shift: TShiftState); override;
    procedure KeyUp(var Key: Word; Shift: TShiftState); override;
  protected
    { Protected declarations }
    FTimer:TTimer;
    procedure LeftClick;dynamic;
    procedure RightClick;dynamic;
    procedure UpClick;dynamic;
    procedure DownClick;dynamic;
    procedure SetContur(Val:Boolean);
    procedure MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer);override;
    procedure MouseUp(Button: TMouseButton; Shift: TShiftState; X, Y: Integer);override;
    procedure Click;override;
  public
    { Public declarations }
    Constructor Create(AOwner:TComponent);override;
    Destructor Destroy;override;
    procedure Paint;override;
  published
    { Published declarations }
    property DrawContur:Boolean read FDrawContur write SetContur default True;
    property TabStop;
    property OnLeftClick:TNotifyEvent read FOnLeftClick write FOnLeftClick;
    property OnRightClick:TNotifyEvent read FOnRightClick write FOnRightClick;
    property OnUpClick:TNotifyEvent read FOnUpClick write FOnUpClick;
    property OnDownClick:TNotifyEvent read FOnDownClick write FOnDownClick;
    property OnEnter;
    property OnExit;
  end;

procedure Register;

implementation

Constructor TRombButtons.Create(AOwner:TComponent);
begin
 inherited Create(AOwner);
 ControlStyle:=ControlStyle-[csSetCaption];
 FDrawContur:=True;
 Width:=99;
 Height:=99;
 Btn:=0;
end;

Destructor TRombButtons.Destroy;
begin
 if FTimer <> nil then
 FTimer.Free;
 inherited Destroy;
end;

procedure TRombButtons.Paint;
begin
 inherited Paint;
 with Canvas do
 begin
  Pen.Color:=clBtnShadow;
  Pen.Width:=2;
  MoveTo(Width div 2,0);
  LineTo(Width,Height div 2);
  LineTo(Width div 2,Height);
  Pen.Color:=clBtnHighlight;
  LineTo(0,Height div 2);
  LineTo(Width div 2,0);
  {---------------}
  Pen.Color:=clBtnShadow;
  MoveTo((Width div 4)-1,(Height div 4)+1);
  LineTo((Width div 2)-1,(Height div 2)+1);
  Pen.Color:=clBtnHighlight;
  MoveTo((Width div 4)+1,(Height div 4)-1);
  LineTo((Width div 2)+1,(Height div 2)-1);
  {---------------}
  Pen.Color:=clBtnShadow;
  MoveTo((Width*3 div 4)-1,(Height div 4)-1);
  LineTo((Width div 2)-1,(Height div 2)-1);
  Pen.Color:=clBtnHighlight;
  MoveTo((Width*3 div 4)+1,(Height div 4)+1);
  LineTo((Width div 2)+1,(Height div 2)+1);
  {---------------}
  Pen.Color:=clBtnShadow;
  MoveTo((Width div 4)-1,(Height*3 div 4)-1);
  LineTo((Width div 2)-1,(Height div 2)-1);
  Pen.Color:=clBtnHighlight;
  MoveTo((Width div 4)+1,(Height*3 div 4)+1);
  LineTo((Width div 2)+1,(Height div 2)+1);
  {---------------}
  Pen.Color:=clBtnShadow;
  MoveTo((Width*3 div 4)-1,(Height*3 div 4)+1);
  LineTo((Width div 2)-1,(Height div 2)+1);
  Pen.Color:=clBtnHighlight;
  MoveTo((Width*3 div 4)+1,(Height*3 div 4)-1);
  LineTo((Width div 2)+2,(Height div 2));
  {---------------}
  Pen.Color:=clBlack;
  if DrawContur then
  begin
   DrawFocusRect(ClientRect);
   Pen.Width:=1;
   MoveTo((Width div 2)+3,0);
   LineTo(Width-1,(Height div 2)-3);
   LineTo(Width-1,(Height div 2)+3);
   LineTo((Width div 2)+3,Height-1);
   LineTo((Width div 2)-3,Height-1);
   LineTo(0,(Height div 2)+3);
   LineTo(0,(Height div 2)-3);
   LineTo((Width div 2)-3,0);
   LineTo((Width div 2)+3,0);
   MoveTo((Width*3 div 4),(Height*3 div 4));
   LineTo((Width div 4),(Height div 4));
   MoveTo((Width*3 div 4),(Height div 4));
   LineTo((Width div 4),(Height*3 div 4));
  end;
  Pen.Width:=3;
  {Up}
  MoveTo(Width div 2,Height div 8);
  LineTo(Width div 2,Height div 2-Height div 8);
  MoveTo(Height div 2+3,Width div 8+3);
  LineTo(Height div 2,Width div 8);
  LineTo(Height div 2-3,Width div 8+3);
  {Down}
  MoveTo(Width div 2,Height div 2+Height div 8);
  LineTo(Width div 2,Height-Height div 8);
  MoveTo(Height div 2+3,Width-Width div 8-3);
  LineTo(Height div 2,Width-Width div 8);
  LineTo(Height div 2-3,Width-Width div 8-3);
  {Left}
  MoveTo(Width div 8,Height div 2);
  LineTo(Width div 2-Width div 8,Height div 2);
  MoveTo(Width div 8+3,Height div 2+3);
  LineTo(Width div 8,Height div 2);
  LineTo(Width div 8+3,Height div 2-3);
  {Right}
  MoveTo(Width div 2+Width div 8,Height div 2);
  LineTo(Width -Width div 8,Height div 2);
  MoveTo(Width-Width div 8-3,Height div 2+3);
  LineTo(Width-Width div 8,Height div 2);
  LineTo(Width-Width div 8-3,Height div 2-3);
 end;
end;

procedure TRombButtons.LeftClick;
begin
 with Canvas do
 begin
  Pen.Color:=clBtnShadow;
  Pen.Width:=2;
  MoveTo(0,Height div 2);
  LineTo(Height div 4,Height div 4+1);
  MoveTo(0,Height div 2);
  LineTo(Height div 4,Height*3 div 4-1);
  Pen.Color:=clRed;
  Pen.Width:=3;
  MoveTo(Width div 8,Height div 2);
  LineTo(Width div 2-Width div 8,Height div 2);
  MoveTo(Width div 8+3,Height div 2+3);
  LineTo(Width div 8,Height div 2);
  LineTo(Width div 8+3,Height div 2-3);
  if Assigned(FOnLeftClick)then FOnLeftClick(Self);
 end;
end;

procedure TRombButtons.RightClick;
begin
 with Canvas do
 begin
  Pen.Color:=clBtnShadow;
  Pen.Width:=2;
  MoveTo(Height div 2+3,Height div 2);
  LineTo(Height*3 div 4+1,Height div 4+2);
  MoveTo(Height div 2+3,Height div 2);
  LineTo(Height*3 div 4+1,Height*3 div 4-2);
  Pen.Color:=clRed;
  Pen.Width:=3;
  MoveTo(Width div 2+Width div 8,Height div 2);
  LineTo(Width -Width div 8,Height div 2);
  MoveTo(Width-Width div 8-3,Height div 2+3);
  LineTo(Width-Width div 8,Height div 2);
  LineTo(Width-Width div 8-3,Height div 2-3);
  if Assigned(FOnRightClick)then FOnRightClick(Self);
 end;
end;

procedure TRombButtons.UpClick;
begin
 with Canvas do
 begin
  Pen.Color:=clBtnShadow;
  Pen.Width:=2;
  MoveTo(Height div 4+1,Height div 4);
  LineTo(Height div 2-2,2);
  MoveTo(Height div 4+3,Height div 4);
  LineTo(Height div 2,Height div 2-3);
  Pen.Color:=clRed;
  Pen.Width:=3;
  MoveTo(Width div 2,Height div 8);
  LineTo(Width div 2,Height div 2-Height div 8);
  MoveTo(Height div 2+3,Width div 8+3);
  LineTo(Height div 2,Width div 8);
  LineTo(Height div 2-3,Width div 8+3);
  if Assigned(FOnUpClick)then FOnUpClick(Self);
 end;
end;

procedure TRombButtons.DownClick;
begin
 with Canvas do
 begin
  Pen.Color:=clBtnShadow;
  Pen.Width:=2;
  MoveTo(Height div 4+1,Height*3 div 4+1);
  LineTo(Height div 2-2,Height div 2+4);
  MoveTo(Height div 4+2,Height*3 div 4+2);
  LineTo(Height div 2,Height);
  Pen.Color:=clRed;
  Pen.Width:=3;
  MoveTo(Width div 2,Height div 2+Height div 8);
  LineTo(Width div 2,Height-Height div 8);
  MoveTo(Height div 2+3,Width-Width div 8-3);
  LineTo(Height div 2,Width-Width div 8);
  LineTo(Height div 2-3,Width-Width div 8-3);
  if Assigned(FOnDownClick)then FOnDownClick(Self);
 end;
end;

procedure TRombButtons.MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var dx:integer;
begin
 inherited MouseDown(Button,Shift,X,Y);
 dx:=abs(Width div 2 -X);
 if X=Y then Exit;
 if x<Width div 2 then
 begin
  if y<Height div 2 -dx then
  begin
   if y>dx then Btn:=1;
  end
  else if (y >Height div 2 -dx)and(y <Height div 2 +dx)then
  begin
   if (y>dx)and(y<Height-dx) then Btn:=2;
  end
  else
  begin
   if y<Height-dx then Btn:=3;
  end;
 end
 else
 begin
  if y<Height div 2 -dx then
  begin
   if y>dx then Btn:=1;
  end
  else if (y >Height div 2 -dx)and(y <Height div 2 +dx)then
  begin
   if (y>dx)and(y<Height-dx) then Btn:=4;
  end
  else
  begin
   if y<Height-dx then Btn:=3;
  end;
 end;
 if FTimer = nil then FTimer:=TTimer.Create(Self);
 FTimer.Interval:=180;
 FTimer.OnTimer:=TimerExpired;
 FTimer.Enabled:=True;
end;

procedure TRombButtons.WMSize(var M: TWMSize);
begin
  inherited;
  if Width<>Height then Height:=Width;
end;

procedure TRombButtons.SetContur(Val:Boolean);
begin
 if Val<>FDrawContur then
 begin
  FDrawContur:=Val;
  Invalidate;
 end;
end;

procedure TRombButtons.MouseUp(Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  inherited MouseUp (Button, Shift, X, Y);
  if FTimer <> nil then
   FTimer.Enabled:=False;
  Invalidate;
end;

procedure TRombButtons.TimerExpired(Sender: TObject);
begin
 FTimer.Interval:=50;
 case Btn of
  1:UpClick;
  2:LeftClick;
  3:DownClick;
  4:RightClick;
 end;
end;

procedure TRombButtons.Click;
begin
 case Btn of
  1:UpClick;
  2:LeftClick;
  3:DownClick;
  4:RightClick;
 end;
end;

procedure TRombButtons.WMSetFocus(var Message: TWMSetFocus);
begin
 SetContur(True);
end;

procedure TRombButtons.WMKillFocus(var Message: TWMKillFocus);
begin
 SetContur(False);
end;

procedure TRombButtons.WMGetDlgCode(var M: TWMGetDlgCode);
begin
  M.Result := dlgc_WantArrows;
end;

procedure TRombButtons.KeyDown(var Key: Word; Shift: TShiftState);
begin
 case Key of
  VK_UP : UpClick;
  VK_DOWN :DownClick;
  VK_LEFT:LeftClick;
  VK_RIGHT:RightClick;
 end;
 inherited KeyDown(Key, Shift);
end;

procedure TRombButtons.KeyUp(var Key: Word; Shift: TShiftState);
begin
 case Key of
  VK_UP ,VK_DOWN ,VK_LEFT,VK_RIGHT: Invalidate;
 end;
 inherited KeyUp(Key, Shift);
end;

procedure Register;
begin
  RegisterComponents('My VCL', [TRombButtons]);
end;

end.
